% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metrics_functions.R
\name{AR}
\alias{AR}
\title{Compute the Anti-Robinson (AR) score}
\usage{
AR(mat, order)
}
\arguments{
\item{mat}{A symmetric numeric distance matrix.}

\item{order}{A permutation vector specifying the new row/column order.}
}
\value{
The AR score (the total number of structural violations).

Please refer to \code{\link{GAP}} for complete usage examples.
}
\description{
Calculates the total number of Anti-Robinson violations over all triplets
in the matrix using the specified ordering. This is equivalent to GAR with a full window.
}
